unit PickEngine;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ComCtrls, ComObj, Speech, TTSVar, ExtCtrls;

type
  TformPickEngine = class(TForm)
    Label1: TLabel;
    lbEngines: TListBox;
    GroupBox1: TGroupBox;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    lblName: TLabel;
    lblLanguage: TLabel;
    lblManufacturer: TLabel;
    lblProduct: TLabel;
    lblModeID: TLabel;
    lblEngineID: TLabel;
    lblSpeaker: TLabel;
    lblStyle: TLabel;
    lblGender: TLabel;
    lblAge: TLabel;
    lblFeatures: TLabel;
    lblInterfaces: TLabel;
    lblSpecific: TLabel;
    cbEngineInterfaces: TComboBox;
    cbFeatures: TComboBox;
    btnGotEngine: TBitBtn;
    BitBtn2: TBitBtn;
    Bevel1: TBevel;
    procedure lbEnginesClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure lbEnginesDblClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formPickEngine: TformPickEngine;

const
  InterfacesString : array[0..6] of string = ('TTSI_ILEXPRONOUNCE', 'TTSI_ITTSATTRIBUTES',
                     'TTSI_ITTSCENTRAL', 'TTSI_ITTSDIALOGS', 'TTSI_ATTRIBUTES',
                     'TTSI_IATTRIBUTES', 'TTSI_ILEXPRONOUNCE2');
  FeaturesString : array[0..16] of string = ('TTSFEATURE_ANYWORD', 'TTSFEATURE_VOLUME',
                     'TTSFEATURE_SPEED', 'TTSFEATURE_PITCH', 'TTSFEATURE_TAGGED',
                     'TTSFEATURE_IPAUNICODE', 'TTSFEATURE_VISUAL', 'TTSFEATURE_WORDPOSITION',
                     'TTSFEATURE_PCOPTIMIZED', 'TTSFEATURE_PHONEOPTIMIZED', 'TTSFEATURE_FIXEDAUDIO',
                     'TTSFEATURE_SINGLEINSTANCE', 'TTSFEATURE_THREADSAFE', 'TTSFEATURE_IPATEXTDATA',
                     'TTSFEATURE_PREFERRED', 'TTSFEATURE_TRANSPLANTED', 'TTSFEATURE_SAPI4');


implementation

uses TTSMain2;

{$R *.DFM}

procedure TformPickEngine.lbEnginesClick(Sender: TObject);
var
 I, J : Integer;
 NumFound : DWord;
 ModeInfo : TTSModeInfo;
begin
  OleCheck(aTTSEnum.Reset);
  for I := 0 to formPickEngine.lbEngines.ItemIndex do
    OleCheck(aTTSEnum.Next(1, ModeInfo, @NumFound));  {Get One}
  lblName.Caption := StrPas(ModeInfo.szModeName);
  lblLanguage.Caption := StrPas(ModeInfo.Language.szDialect);
  lblManufacturer.Caption := StrPas(ModeInfo.szMfgName);
  lblProduct.Caption := StrPas(ModeInfo.szProductName);
  lblModeID.Caption := GUIDToString(ModeInfo.gModeID);
  lblEngineID.Caption := GUIDToString(ModeInfo.gEngineID);
  lblSpeaker.Caption := StrPas(ModeInfo.szSpeaker);
  lblStyle.Caption := StrPas(ModeInfo.szStyle);
  case ModeInfo.wGender of
    0 : lblGender.Caption := 'GENDER_NEUTRAL';
    1 : lblGender.Caption := 'GENDER_FEMALE';
    2 : lblGender.Caption := 'GENDER_MALE';
  end;
  case ModeInfo.wAge of
    1 : lblAge.Caption := 'TTSAGE_BABY';
    3 : lblAge.Caption := 'TTSAGE_TODDLER';
    6 : lblAge.Caption := 'TTSAGE_CHILD';
    14: lblAge.Caption := 'TTSAGE_ADOLESCENT';
    30: lblAge.Caption := 'TTSAGE_ADULT';
    70: lblAge.Caption := 'TTSAGE_ELDERLY';
  end;
  cbFeatures.Clear;
  lblFeatures.Caption := IntToStr(ModeInfo.dwFeatures);
  J := ModeInfo.dwFeatures;
  for I := 0 to 16 do begin
    if (J AND 1 = 1) then cbFeatures.Items.Add(FeaturesString[I]);
    J := J shr 1;
  end;
  cbFeatures.ItemIndex := 0;
  cbEngineInterfaces.Clear;
  J := ModeInfo.dwInterfaces;
  for I := 0 to 6 do begin
    if (J AND 1 = 1) then cbEngineInterfaces.Items.Add(InterfacesString[I]);
    J := J shr 1;
  end;
  cbEngineInterfaces.ItemIndex := 0;
  lblInterfaces.Caption := IntToStr(ModeInfo.dwInterfaces);
  lblSpecific.Caption := IntToStr(ModeInfo.dwEngineFeatures);
  if assigned(fpModeInfo) then dispose(fpModeInfo);
  new(fpModeInfo);
  fpModeInfo^ := ModeInfo;
end;

procedure TformPickEngine.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Form1.RichEdit1.Lines.Add('Selected Engine Named "' + lblName.Caption + '"');
end;

procedure TformPickEngine.lbEnginesDblClick(Sender: TObject);
begin
  ModalResult := mrOk;
end;

procedure TformPickEngine.FormShow(Sender: TObject);
begin
  if lbEngines.ItemIndex > -1 then lbEnginesClick(Sender);    
end;

end.
