unit TTSMain2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ComObj, ActiveX, speech, TTSVar, ExtCtrls, Buttons;

type

  TTSBufNotifySink = class;
  TTSNotifySink = class;

  TForm1 = class(TForm)
    RichEdit1: TRichEdit;
    reTextToSay: TRichEdit;
    cbxCheckCreateBuffNotifySInk: TCheckBox;
    Panel1: TPanel;
    PlayBtn: TSpeedButton;
    PauseBtn: TSpeedButton;
    StopBtn: TSpeedButton;
    StatusLabel: TLabel;
    cbxCheckCreateNotifySink: TCheckBox;
    Label6: TLabel;
    Label7: TLabel;
    Panel2: TPanel;
    cbxCheckCreateAudio: TCheckBox;
    cbxCheckEnumEngines: TCheckBox;
    cbxCheckStartEngine: TCheckBox;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Panel3: TPanel;
    Label8: TLabel;
    lblPitchMin: TLabel;
    lblPitchMax: TLabel;
    lblSpeedMin: TLabel;
    lblSpeedMax: TLabel;
    lblPitchCurrent: TLabel;
    lblSpeedCurrent: TLabel;
    SpeedTB: TTrackBar;
    PitchTB: TTrackBar;
    Label16: TLabel;
    VolumeTB: TTrackBar;
    cbxCheckAttributes: TCheckBox;
    Label17: TLabel;
    Panel4: TPanel;
    btnInjectPitch: TButton;
    btnInjectSpeed: TButton;
    btnInjectVolume: TButton;
    Label9: TLabel;
    Bevel1: TBevel;
    cbxEnableDialogs: TCheckBox;
    btnAboutDlg: TButton;
    Label10: TLabel;
    btnGeneralDlg: TButton;
    btnLexiconDlg: TButton;
    btnTrainDlg: TButton;
    btnPickEngine: TButton;
    Label1: TLabel;
    btnTags: TButton;
    cmbEngines: TComboBox;
    procedure FormCreate(Sender: TObject);
    procedure cbxCheckCreateAudioClick(Sender: TObject);
    procedure cbxCheckEnumEnginesClick(Sender: TObject);
    procedure cbxCheckStartEngineClick(Sender: TObject);
    procedure btSpeakClick(Sender: TObject);
    procedure cbxAudioPauseClick(Sender: TObject);
    procedure btAudioResetClick(Sender: TObject);
    procedure cbxCheckCreateBuffNotifySInkClick(Sender: TObject);
    procedure cbxCheckCreateNotifySinkClick(Sender: TObject);
    procedure ResetButtons;
    procedure cbxCheckAttributesClick(Sender: TObject); 
    procedure CheckSpeed;
    procedure CheckPitch;
    procedure CheckVolume;
    procedure btnInjectPitchClick(Sender: TObject);
    procedure btnInjectSpeedClick(Sender: TObject);
    procedure btnInjectVolumeClick(Sender: TObject);
    procedure SpeedTBChange(Sender: TObject);
    procedure PitchTBChange(Sender: TObject);
    procedure cbxEnableDialogsClick(Sender: TObject);
    procedure btnAboutDlgClick(Sender: TObject);
    procedure btnGeneralDlgClick(Sender: TObject);
    procedure btnLexiconDlgClick(Sender: TObject);
    procedure btnTrainDlgClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnPickEngineClick(Sender: TObject);
    procedure btnTagsClick(Sender: TObject);
    procedure cmbEnginesChange(Sender: TObject);
  private     {
    fITTSCentral : ITTSCentral;
    fpModeInfo : PTTSModeInfo;
    aTTSEnum : ITTSEnum;
    fIAMM : IAudioMultimediaDevice;
    fPhonemeOut: TSData;
    fITTSAttributes : ITTSAttributes;
    fITTSDialogs : ITTSDialogs;
    fpEngineInfo : Pointer;
    fTTSNotifySink : ITTSNotifySink;
    fTTSBufNotifySink : ITTSBufNotifySink;
    fdwKey: DWord;
    fLastTimeStamp : Int64;}
  public
  end;

  TTSBufNotifySink = class(TInterfacedObject, ITTSBufNotifySink)
  private
    fForm : TForm1;
  protected
   function TextDataDone(qTimeStamp: QWORD; dwFlags: DWORD): HResult; stdcall;
   function TextDataStarted(qTimeStamp: QWORD) : HResult; stdcall;
   function BookMark(qTimeStamp: QWORD; dwMarkNum: DWORD) : HResult; stdcall;
   function WordPosition(qTimeStamp: QWORD; dwByteOffset: DWORD) : HResult; stdcall;
  public
   constructor create(aForm : TForm1);
  end; //ITTSBufNotifySink

  TTSNotifySink = class(TInterfacedObject, ITTSNotifySink)
  private
    fForm : TForm1;
  protected
   function AttribChanged(dwAttribute: DWORD) : HResult; stdcall;
   function AudioStart(qTimeStamp: QWORD) : HResult; stdcall;
   function AudioStop(qTimeStamp: QWORD) : HResult; stdcall;
   function Visual(qTimeStamp: QWORD;
                   cIPAPhoneme: Char;
                   cEnginePhoneme: Char;
                   dwHints: DWORD;
                   apTTSMouth: PTTSMouth) : HResult; stdcall;
  public
      constructor create(aForm : TForm1);
  end; //TTSNotifySink

var
  Form1: TForm1;                
  CurrentSpeed : DWord;
  CurrentPitch : Word;
  CurrentVolume : DWord;

  LowSpeed, HighSpeed : DWord;
  LowPitch, HighPitch : Word;
  LowVolume, HighVolume : DWord;

implementation

uses PickEngine, TagsDlg;

{$R *.DFM}

{-------------------------TTSBufNotifySink ---------------------------------------}
constructor TTSBufNotifySink.create(aForm : TForm1);
begin
  fForm := aForm;
end;

function TTSBufNotifySink.TextDataDone(qTimeStamp: QWORD; dwFlags: DWORD) : HResult;
begin
  result := 0;
  fLastTimeStamp := qTimeStamp;
  fForm.RichEdit1.Lines.Add('Event TextDataDone, TimeStamp :' +
     FloattoStr(qTimeStamp) + ' Flags :' + inttostr(dwFlags));
  { Give visual cue that the Text is finished }
  fForm.StatusLabel.Caption := 'TextDataDone...';
  fForm.StatusLabel.Font.Color := clRed;
  fForm.StatusLabel.Font.Style := [fsBold, fsItalic];
  fForm.Update;
  Sleep(1000);
  if assigned(fTTSBufNotifySink) then fForm.ResetButtons;
end;

function TTSBufNotifySink.TextDataStarted(qTimeStamp: QWORD) : HResult;
begin
  result := 0;
  fLastTimeStamp := qTimeStamp;
  fForm.RichEdit1.Lines.Add('Event TextDataStarted, TimeStamp :' +
     FloattoStr(qTimeStamp));
end;

function TTSBufNotifySink.BookMark(qTimeStamp: QWORD; dwMarkNum: DWORD) : HResult;
begin
  result := 0;
  fLastTimeStamp := qTimeStamp;
  fForm.RichEdit1.Lines.Add('Event BookMark, TimeStamp :' +
     FloattoStr(qTimeStamp) + ' MarkNum :' + inttostr(dwMarkNum));
end;

function TTSBufNotifySink.WordPosition(qTimeStamp: QWORD; dwByteOffset: DWORD) : HResult;
begin
  result := 0;
  fLastTimeStamp := qTimeStamp;
  fForm.RichEdit1.Lines.Add('Event WordPosition, TimeStamp :' +
     FloattoStr(qTimeStamp) + ' Offset :' + inttostr(dwByteOffset));
end;

{--------------------------TTSNotifySink-------------------------}
constructor TTSNotifySink.create(aForm : TForm1);
begin
  fForm := aForm;
end;

function TTSNotifySink.AttribChanged(dwAttribute: DWORD) : HResult;
var
 S:String;
begin
  result := 0;
  case dwAttribute of
   TTSNSAC_REALTIME : S := 'Realtime';
   TTSNSAC_PITCH    : S := 'Pitch';
   TTSNSAC_SPEED    : S := 'Speed';
   TTSNSAC_VOLUME   : S := 'Volume';
  end;
  fForm.RichEdit1.Lines.Add('Event AttribChanged, Attribute :' + S);
end;

function TTSNotifySink.AudioStart(qTimeStamp: QWORD) : HResult;
begin
  result := 0;
  fLastTimeStamp := qTimeStamp;
  fForm.RichEdit1.Lines.Add('Event AudioStart, TimeStamp :' +
     FloattoStr(qTimeStamp));
end;

function TTSNotifySink.AudioStop(qTimeStamp: QWORD) : HResult;
begin
  result := 0;
  fLastTimeStamp := qTimeStamp;
  fForm.RichEdit1.Lines.Add('Event AudioStop, TimeStamp :' +
     FloattoStr(qTimeStamp));
end;

function TTSNotifySink.Visual(qTimeStamp: QWORD;
                cIPAPhoneme: Char;
                cEnginePhoneme: Char;
                dwHints: DWORD;
                apTTSMouth: PTTSMouth) : HResult;
var
  tmp : String;
begin
  result := 0;
  if cEnginePhoneme = '@' then exit;
  fLastTimeStamp := qTimeStamp;
  tmp := '';
  if dwHints <> 0 then
  begin
    If (TTSNSHINT_QUESTION and dwHints) <> 0 then
      tmp := tmp + 'Question ';
    If (TTSNSHINT_STATEMENT and dwHints) <> 0 then
      tmp := tmp + 'Statement ';
    If (TTSNSHINT_COMMAND and dwHints) <> 0 then
      tmp := tmp + 'Command ';
    If (TTSNSHINT_EXCLAMATION and dwHints) <> 0 then
      tmp := tmp + 'Exclamation ';
    If (TTSNSHINT_EMPHASIS and dwHints) <> 0 then
      tmp := tmp + 'Emphasis ';
  end
  else
    tmp := 'None';
  fForm.RichEdit1.Lines.Add('Event Visual, TStamp :'+FloattoStr(qTimeStamp)+
      ' IPAPhoneme :' + intToStr(ord(cIPAPhoneme)) +
      ' Phoneme :' + cEnginePhoneme +
      ' Hints :' + tmp +
      ' Data :'+inttostr(apTTSMouth^.bMouthHeight)+','+
        inttostr(apTTSMouth^.bMouthWidth));
end;

{---------------------------------------------------------------------------}
{____________/TForm\________________________________________________________}
{---------------------------------------------------------------------------}
procedure TForm1.FormCreate(Sender: TObject);
begin
  fITTSCentral := nil;
  fpModeInfo := nil;
  aTTSEnum := nil;
  fpEngineInfo := nil;
  fIAMM := nil;
  fITTSAttributes := nil;
  fITTSDialogs := nil;
  fTTSNotifySink := nil;
  fTTSBufNotifySink := nil;
  fPhonemeOut.pData := Nil;
  fPhonemeOut.dwSize := 0;
  formPickEngine := TformPickEngine.Create(Form1);
  NumChrSel := 0;
end;

procedure TForm1.cbxCheckCreateAudioClick(Sender: TObject);
begin
 if cbxCheckCreateAudio.checked then
 begin
   try
     OleCheck(CoCreateInstance(CLSID_MMAudioDest, Nil, CLSCTX_ALL,
           IID_IAudioMultiMediaDevice, fIAMM));
     RichEdit1.Lines.Add('CoCreateInstance IID_IAudioMultiMediaDevice Success');
   except
     RichEdit1.Lines.Add('CoCreateInstance IID_IAudioMultiMediaDevice Failed');
   end;
 end
 else
 begin
   if assigned(fIAMM) then
     fIAMM := Nil;
 end;
end;

procedure TForm1.cbxCheckEnumEnginesClick(Sender: TObject);
var
  NumFound : DWord;
  ModeInfo : TTSModeInfo;
  I : Integer;
begin
  if cbxCheckEnumEngines.Checked then
  begin
    I := 0;
    {Create TTS Enumerator object with the interface ITTSEnum and return the pointer in aITTSEnum}
    OleCheck(CoCreateInstance(CLSID_TTSEnumerator, Nil, CLSCTX_ALL, IID_ITTSEnum, aTTSEnum));
    OleCheck(aTTSEnum.Reset);
    OleCheck(aTTSEnum.Next(1, ModeInfo, @NumFound));  {First Get}
    While NumFound > 0 do
    begin
      cmbEngines.Items.Add(String(ModeInfo.szModeName));
      formPickEngine.lbEngines.Items.Add(StrPas(ModeInfo.szModeName));
      OleCheck(aTTSEnum.Next(1, ModeInfo, @NumFound)); {additional gets}
      Inc(I);
    end;
  end
  else
  begin
    if assigned(aTTSEnum) then
       aTTSEnum := nil;
    formPickEngine.lbEngines.items.clear;
    I := 0;
  end;
  Label1.Caption := IntToStr(I) + ' Engines Available';
end;

procedure TForm1.cbxCheckStartEngineClick(Sender: TObject);
begin
    try
      RichEdit1.Lines.Add(' Selecting Engine...');
      Update;
      OleCheck(aTTSEnum.Select(fpModeInfo^.gModeID, fITTSCentral, IUnknown(fIAMM)));
      RichEdit1.Lines.Add('Engine Select Success');
    except
      RichEdit1.Lines.Add('Engine Select Failed');
    end;
end;

procedure TForm1.btSpeakClick(Sender: TObject);
var
  SData : TSData;
begin
  if not assigned(fITTSCentral) then
  begin
    RichEdit1.Lines.Add('The Engine object does not exist.');
    PlayBtn.Down := False;
    exit;
  end;
  { If user presses Play when the engine is Speaking, then force button down
    and exit procedure }
  if NOT PlayBtn.Down then begin
    PlayBtn.Down := True;
    exit;
  end;
  { Get the text to speak }
  SData.dwSize := length(reTextToSay.Text) + 1;
  SData.pData := pChar(reTextToSay.Text);

  { If Speaking is paused, then Resume }
  if StatusLabel.Caption = 'AudioPause...' then begin
    try
      OleCheck(fITTSCentral.AudioResume);
      StatusLabel.Caption := 'AudioResumed...';
      StatusLabel.Font.Style := [fsBold, fsItalic];
      StatusLabel.Font.Color := clGreen;
    except
      RichEdit1.Lines.Add('Check AudioResume Failed');
      exit;
    end;
  end else begin
  { Begin Speaking Text }
  Try
    OleCheck(fITTSCentral.TextData (CHARSET_TEXT, 0,
      SData, pointer(fTTSBufNotifySink), IID_ITTSBufNotifySink));
    RichEdit1.SetFocus;
    RichEdit1.Lines.Add('Speak '+ ' <Charset_Text> - Success');
    StatusLabel.Caption := 'Speaking...';
    StatusLabel.Font.Style := [fsBold, fsItalic];
    StatusLabel.Font.Color := clGreen;
  Except
    RichEdit1.Lines.Add('Speak '+ ' <Charset_Text> - Failed'); 
    PlayBtn.Down := False;
  end; {Except}
  end;
end;

procedure TForm1.cbxAudioPauseClick(Sender: TObject);
begin
  if not assigned(fITTSCentral) then begin
    showmessage('Engine must be Selected/Started first');
    exit;
  end;                                      
  { If user presses Pause when the engine is already Paused, then force button down
    and exit procedure }
  if NOT PauseBtn.Down then begin
    PauseBtn.Down := True;
    exit;
  end;

  if PlayBtn.Down then exit;
  { Attempt to Pause the Audio }
  try
    OleCheck(fITTSCentral.AudioPause);
    StatusLabel.Caption := 'AudioPause...';
    StatusLabel.Font.Color := clYellow;
    StatusLabel.Font.Style := [fsBold, fsItalic];
  except
    RichEdit1.Lines.Add('Check AudioPause Failed');
  end;
end;

procedure TForm1.ResetButtons;
begin
  StatusLabel.Font.Style := [];
  StatusLabel.Font.Color := clBlack;
  StatusLabel.Caption := 'Press Play to SpeakText';
  PlayBtn.Down := False;
  StopBtn.Down := False;
end;

procedure TForm1.btAudioResetClick(Sender: TObject);
begin
  if not assigned(fITTSCentral) then begin
    showmessage('Engine must be Selected/Started first');
    exit;
  end;
  if PlayBtn.Down then exit;
  { Attempt to Reset the Audio }
  try
    StatusLabel.Caption := 'AudioReset...';
    StatusLabel.Font.Color := clRed;
    StatusLabel.Font.Style := [fsBold, fsItalic];
    Update;  { Show the new label caption }
    OleCheck(fITTSCentral.AudioReset);
    RichEdit1.Lines.Add('Check AudioReset Success');
    Sleep(1000);  { Give the user time to read caption }
    ResetButtons;
  except
    RichEdit1.Lines.Add('Check AudioReset Failed');
  end;
end;

procedure TForm1.cbxCheckCreateBuffNotifySInkClick(Sender: TObject);
begin
  if not assigned(fITTSCentral) then
  begin
    if cbxCheckCreateBuffNotifySInk.checked then
    begin
      cbxCheckCreateBuffNotifySInk.checked := False;
      showmessage('Engine must be Selected/Started first');
    end;
    exit;
  end;
  if cbxCheckCreateBuffNotifySInk.checked then
  begin
    try
      fTTSBufNotifySink := TTSBufNotifySink.Create(Self);
      RichEdit1.Lines.Add('Check Create BufNotifySink Success');
    except
      RichEdit1.Lines.Add('Check Create BufNotifySink Failed');
    end;
  end
  else
  begin
    if assigned(fTTSBufNotifySink) then
    begin
      fTTSBufNotifySink := nil;
      RichEdit1.Lines.Add('Check Free BufNotifySink Success');
    end;
  end;
end;

procedure TForm1.cbxCheckCreateNotifySinkClick(Sender: TObject);
begin
  if not assigned(fITTSCentral) then
  begin
    if cbxCheckCreateNotifySink.checked then
    begin
      cbxCheckCreateNotifySink.checked := False;
      showmessage('Engine must be Selected/Started first');
    end;
    exit;
  end;
  if cbxCheckCreateNotifySink.checked then
  begin
    try
      fTTSNotifySink := TTSNotifySink.Create(Self);
      RichEdit1.Lines.Add('Check Create Engine NotifySink Success');
      try
        OleCheck(fITTSCentral.Register( pointer(fTTSNotifySink), IID_ITTSNotifySink, fdwKey));
        RichEdit1.Lines.Add('Check Register Engine NotifySink Success');
      except
        fTTSNotifySink := nil;
        RichEdit1.Lines.Add('Check Register Engine NotifySink Failed');
      end;
    except
      RichEdit1.Lines.Add('Check Create Engine NotifySink Failed');
    end;
  end
  else
  begin
    if assigned(fTTSNotifySink) then
    begin
      try
        fITTSCentral.unregister(fdwKey);
        RichEdit1.Lines.Add('Check UnRegister Engine NotifySink Success');
        fTTSNotifySink := Nil;
        RichEdit1.Lines.Add('Check Free Engine NotifySink Success');
      except
        RichEdit1.Lines.Add('Check UnRegister Engine NotifySink Failed');
      end;
    end;
  end;
end;

procedure TForm1.CheckSpeed;
var
  P : DWord;
begin
  If (TTSFEATURE_SPEED and fpModeInfo.dwFeatures) <> 0 then begin
    RichEdit1.Lines.Add('Get TTSFEATURE_SPEED Success');
    { If Speed is supported, then save result as the CurrentSpeed }
    if not(TTSERR_NOTSUPPORTED = fITTSAttributes.SpeedGet(CurrentSpeed)) then begin
      RichEdit1.Lines.Add('Check SpeedGet Success');
      if not(TTSERR_NOTSUPPORTED = fITTSAttributes.SpeedSet(P)) then begin
        RichEdit1.Lines.Add('Check SpeedSet Success');
        lblSpeedCurrent.Caption := IntToStr(CurrentSpeed);
        { Get the engines Minimum speed }
        fITTSAttributes.SpeedSet(TTSATTR_MINSPEED);
        fITTSAttributes.SpeedGet(LowSpeed);
        lblSpeedMin.Caption := IntToStr(LowSpeed);
        { Get the engines Maximum speed }
        fITTSAttributes.Speedset(TTSATTR_MAXSPEED);
        fITTSAttributes.SpeedGet(HighSpeed);
        lblSpeedMax.Caption := IntToStr(HighSpeed);
        fITTSAttributes.SpeedSet(CurrentSpeed);  {Reset the Speed to default}
        { Initialize the Trackbar }
        SpeedTB.Enabled := True;
        SpeedTB.Max := HighSpeed;
        SpeedTB.Min := LowSpeed;
        SpeedTb.Position := CurrentSpeed;
        SpeedTB.Frequency := Trunc((HighSpeed - LowSpeed) / 10);
      end else RichEdit1.Lines.Add('Check SpeedSet Failed')
    end else RichEdit1.Lines.Add('Check SpeedGet Failed')
  end else begin
    RichEdit1.Lines.Add('Get TTSFEATURE_SPEED Failed');
    exit;
  end;
end;

procedure TForm1.CheckPitch;
var
  P : DWord;
begin
  If (TTSFEATURE_PITCH and fpModeInfo.dwFeatures) <> 0 then begin
    RichEdit1.Lines.Add('Engine Claims Pitch is Supported');
    { If Pitch is supported, then save result as the CurrentPitch }
    if not(TTSERR_NOTSUPPORTED = fITTSAttributes.PitchGet(CurrentPitch)) then begin
      RichEdit1.Lines.Add('Check PitchGet Success');
      if not(TTSERR_NOTSUPPORTED = fITTSAttributes.PitchSet(P)) then begin
        RichEdit1.Lines.Add('Check PitchSet Success');
        lblPitchCurrent.Caption := IntToStr(CurrentPitch);
        { Get the engines Minimum pitch }
        fITTSAttributes.PitchSet(TTSATTR_MINPitch);
        fITTSAttributes.PitchGet(LowPitch);
        lblPitchMin.Caption := IntToStr(LowPitch); 
        { Get the engines Maximum pitch }
        fITTSAttributes.Pitchset(TTSATTR_MAXPitch);
        fITTSAttributes.PitchGet(HighPitch);
        lblPitchMax.Caption := IntToStr(HighPitch);
        fITTSAttributes.PitchSet(CurrentPitch); {Reset the Speed to default}
        { Initialize the Trackbar }
        PitchTB.Enabled := True;
        PitchTB.Max := HighPitch;
        PitchTB.Min := LowPitch;
        PitchTB.Frequency := Trunc((HighPitch - LowPitch) / 10);
        PitchTB.Position := CurrentPitch;
      end else RichEdit1.Lines.Add('Check PitchSet Failed')
    end else RichEdit1.Lines.Add('Check PitchGet Failed')
  end else begin
    RichEdit1.Lines.Add('Get TTSFEATURE_Pitch Failed');
    exit;
  end;
end;

procedure TForm1.CheckVolume;
var
  P : DWord;
begin
  If (TTSFEATURE_Volume and fpModeInfo.dwFeatures) <> 0 then begin
    RichEdit1.Lines.Add('Engine Claims Volume is Supported');
    { If Volume is supported, then save result as the CurrentVolume }
    if not(TTSERR_NOTSUPPORTED = fITTSAttributes.VolumeGet(CurrentVolume)) then begin
      RichEdit1.Lines.Add('Check VolumeGet Success');
      if not(TTSERR_NOTSUPPORTED = fITTSAttributes.VolumeSet(P)) then begin
        RichEdit1.Lines.Add('Check VolumeSet Success');   
        { Get the engines Minimum volume }
        fITTSAttributes.VolumeSet(TTSATTR_MINVolume);
        fITTSAttributes.VolumeGet(LowVolume);
        { Get the engines Maximum pitch }
        fITTSAttributes.VolumeSet(TTSATTR_MAXVolume);
        fITTSAttributes.VolumeGet(HighVolume);
        fITTSAttributes.VolumeSet(CurrentVolume);  {Reset the Volume to default}
        { Initialize the Trackbar }
        VolumeTB.Enabled := True;
        { Volume is a DWord, but TTrackBar.Max and Position are Integers,
          so HighVolume and CurrentVolume must be "Massaged" }
        VolumeTB.Max := Trunc(HighVolume / 100000);
        VolumeTB.Min := LowVolume;
        VolumeTB.Position := Trunc(CurrentVolume / 100000);
      end else RichEdit1.Lines.Add('Check VolumeSet Failed')
    end else RichEdit1.Lines.Add('Check VolumeGet Failed')
  end else begin
    RichEdit1.Lines.Add('Get TTSFEATURE_Volume Failed');
    exit;
  end;
end;

procedure TForm1.cbxCheckAttributesClick(Sender: TObject);
begin
  if not assigned(fITTSCentral) then
  begin
    if cbxCheckAttributes.checked then
    begin
      cbxCheckAttributes.checked := False;
      showmessage('Engine must be Selected/Started first');
    end;
    exit;
  end;
  if (TTSI_ITTSATTRIBUTES and fpModeInfo^.dwInterfaces) <> 0 then
  begin
    if cbxCheckAttributes.Checked then
    begin
      try
        OleCheck(fITTSCentral.QueryInterface(IID_ITTSAttributes, fITTSAttributes));
        RichEdit1.Lines.Add('Check Create Attributes Interface Success');
        btnTags.Enabled := True;
        btnInjectPitch.Enabled := True;
        btnInjectSpeed.Enabled := True;
        btnInjectVolume.Enabled := True;
        CheckSpeed;
        CheckPitch;
        CheckVolume;
      except
        RichEdit1.Lines.Add('Check Create Attributes Interface Failed');
      end;
    end
    else
    begin
      try
        if assigned(fITTSAttributes) then
          fITTSAttributes := Nil;
          RichEdit1.Lines.Add('Check Release Attributes Interface Success');
          btnTags.Enabled := False;
          btnInjectPitch.Enabled := False;
          btnInjectSpeed.Enabled := False;
          btnInjectVolume.Enabled := False;
          PitchTB.Enabled := False;
          SpeedTB.Enabled := False;
          VolumeTB.Enabled := False;
      except
        RichEdit1.Lines.Add('Check Release Attributes Interface Failed');
        fITTSAttributes := Nil;
      end;
    end;
  end
  else
  begin
    RichEdit1.Lines.Add('Attributes Interface Not Supported');
    cbxCheckAttributes.Checked := False;
  end;
end;

procedure TForm1.btnInjectPitchClick(Sender: TObject);
var
  PitchP : array[0..40] of Char;
begin
  StrPCopy(PitchP, '\Pit=' + lblPitchCurrent.Caption + '\');
  try
    OleCheck(fITTSCentral.Inject(PitchP));
    RichEdit1.Lines.Add('Inject Pitch Change - Success');
  except
    RichEdit1.Lines.Add('Inject Pitch Change - Failed');
  end;
end;

procedure TForm1.btnInjectSpeedClick(Sender: TObject);
var
  SpeedP : array[0..40] of Char;
begin
  StrPCopy(SpeedP, '\Spd=' + lblSpeedCurrent.Caption + '\');
  try
    OleCheck(fITTSCentral.Inject(SpeedP));
    RichEdit1.Lines.Add('Inject Speed Change - Success');
  except
    RichEdit1.Lines.Add('Inject Speed Change - Failed');
  end;
end;

procedure TForm1.btnInjectVolumeClick(Sender: TObject);
var
  VolumeP : array[0..40] of Char;
begin                                     
  StrPCopy(VolumeP, '\Vol=' + IntToStr(VolumeTB.Position) + '\');
  try
    OleCheck(fITTSCentral.Inject(VolumeP));
    RichEdit1.Lines.Add('Inject Volume Change - Success');
  except
    RichEdit1.Lines.Add('Inject Volume Change - Failed');
  end;
end;

procedure TForm1.SpeedTBChange(Sender: TObject);
begin                     
  lblSpeedCurrent.Caption := IntToStr(SpeedTB.Position);
end;

procedure TForm1.PitchTBChange(Sender: TObject);
begin                   
  lblPitchCurrent.Caption := IntToStr(PitchTB.Position);
end;

procedure TForm1.cbxEnableDialogsClick(Sender: TObject);
begin
  if not assigned(fITTSCentral) then
  begin
    if cbxEnableDialogs.checked then
    begin
      cbxEnableDialogs.checked := False;
      showmessage('Engine must be Selected/Started first');
    end;
    exit;
  end;
  if cbxEnableDialogs.checked then
  begin
    try
      OleCheck(fITTSCentral.QueryInterface(IID_ITTSDialogs, fITTSDialogs));
      RichEdit1.Lines.Add('Check Create Dialogs Interface Success');
      btnAboutDlg.Enabled := True;
      btnGeneralDlg.Enabled := True;
      btnLexiconDlg.Enabled := True;
      btnTrainDlg.Enabled := True;
    except
      RichEdit1.Lines.Add('Check Create Dialogs Interface Failed');
    end;
  end
  else
  begin
    if assigned(fITTSDialogs) then
    begin
      fITTSDialogs := nil;
      RichEdit1.Lines.Add('Check Free ITTSDialogs Success');
      btnAboutDlg.Enabled := False;
      btnGeneralDlg.Enabled := False;
      btnLexiconDlg.Enabled := False;
      btnTrainDlg.Enabled := False;
    end;
  end;
end;

procedure TForm1.btnAboutDlgClick(Sender: TObject);
begin
  try
    OleCheck(fITTSDialogs.AboutDlg(Handle, nil));
    RichEdit1.Lines.Add('Display About Dialog Success');
  except                                                
    RichEdit1.Lines.Add('Display About Dialog Failed');
  end;
end;

procedure TForm1.btnGeneralDlgClick(Sender: TObject);
begin
  try
    OleCheck(fITTSDialogs.GeneralDlg(Handle, nil));
    RichEdit1.Lines.Add('Display General Dialog Success');
  except
    RichEdit1.Lines.Add('Display General Dialog Failed');
  end;
end;

procedure TForm1.btnLexiconDlgClick(Sender: TObject);
begin
  try
    OleCheck(fITTSDialogs.LexiconDlg(Handle, nil));
    RichEdit1.Lines.Add('Display Lexicon Dialog Success');
  except
    RichEdit1.Lines.Add('Display Lexicon Dialog Failed');
  end;
end;

procedure TForm1.btnTrainDlgClick(Sender: TObject);
begin
  try
    OleCheck(fITTSDialogs.TranslateDlg(Handle, nil));
    RichEdit1.Lines.Add('Display General Training Dialog Success');
  except
    RichEdit1.Lines.Add('Display General Training Dialog Failed');
  end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  RichEdit1.SelAttributes.Style := [fsBold];  { Make the next line Bold }
  RichEdit1.Lines.Add('  Closing the Demo...');
  RichEdit1.SelAttributes.Style := [];  { Return the font style to Normal }
  Update;
  cbxCheckStartEngineClick(Sender); { Try to release engine }
  Update;       { Show the Success/Error Message in the RichEdit }
  Sleep(1000);  { Give user time to read message }
  cbxCheckCreateAudioClick(Sender); { Free Audio Destination }
  Update;       { Show the Success/Error Message in the RichEdit }
  Sleep(1000);  { Give user time to read message }  
  formPickEngine.Free;
end;

procedure TForm1.btnPickEngineClick(Sender: TObject);
begin
  formPickEngine.lbEngines.ItemIndex := cmbEngines.ItemIndex;
  formPickEngine.ShowModal;
  if formPickEngine.ModalResult = mrOk then begin
    Label1.Caption := formPickEngine.lblName.Caption;
    cmbEngines.ItemIndex := formPickEngine.lbEngines.ItemIndex;
  end;
  { If we're switching from one engine to another, then Disable Old / Enable New }
  if cbxCheckStartEngine.Checked = True then cbxCheckStartEngineClick(Sender);
{  formPickEngine.Hide;        }
end;

procedure TForm1.btnTagsClick(Sender: TObject);
begin
  frmInject := TfrmInject.Create(Form1);
  with frmInject do begin
    seSpd.MaxValue := HighSpeed;
    seSpd.MinValue := LowSpeed;
    seSpd.Text := IntToStr(CurrentSpeed);
    seRSpd.Text := '100';
    sePit.MaxValue := HighPitch;
    sePit.MinValue := LowPitch;
    sePit.Text := IntToStr(CurrentPitch);
    seRPit.Text := '100';
    seVol.MaxValue := Trunc(HighVolume / 100000);
    seVol.MinValue := LowVolume;
    seVol.Text := IntToStr(Trunc(HighVolume / 100000));
    cbxCtx.ItemIndex := 7;
    Caption := 'Control Tags - ' + Label1.Caption;

    ShowModal;
    Free;
  end;
end;

procedure TForm1.cmbEnginesChange(Sender: TObject);
var
 I : Integer;
 NumFound : DWord;
 ModeInfo : TTSModeInfo;
begin
  if not assigned(attsEnum) then exit;
  OleCheck(aTTSEnum.Reset);
  for I := 0 to cmbEngines.ItemIndex do
    OleCheck(aTTSEnum.Next(1, ModeInfo, @NumFound));  {Get One}
  if assigned(fpModeInfo) then dispose(fpModeInfo);
  new(fpModeInfo);
  fpModeInfo^ := ModeInfo;
end;

end.

// ITTSFind is not being tested that needs to be implemented.
