unit TagsDlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, CheckLst, ComCtrls, ComObj, Spin, Speech, TTSVar, Buttons,
  ExtCtrls;

type
  TfrmInject = class(TForm)
    clbChr: TCheckListBox;
    RichEdit1: TRichEdit;
    ebCom: TEdit;
    cbxCtx: TComboBox;
    ebEng: TEdit;
    seMrk: TSpinEdit;
    sePau: TSpinEdit;
    Label1: TLabel;
    sePit: TSpinEdit;
    Label2: TLabel;
    sePra: TSpinEdit;
    Label3: TLabel;
    ebPrnText: TEdit;
    ebPrnPro: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    cbxPrt: TComboBox;
    Label7: TLabel;
    Label8: TLabel;
    seRPit: TSpinEdit;
    seRPrn: TSpinEdit;
    seRSpd: TSpinEdit;
    btnReset: TButton;
    btnSpeak: TBitBtn;
    btnCom: TButton;
    btnChr: TButton;
    btnCtx: TButton;
    btnDem: TButton;
    btnEmp: TButton;
    btnEng: TButton;
    btnPra: TButton;
    btnMrk: TButton;
    btnPau: TButton;
    btnPit: TButton;
    btnRPrn: TButton;
    btnRPit: TButton;
    btnRSpd: TButton;
    btnPrt: TButton;
    btnPrn: TButton;
    seVol: TSpinEdit;
    seSpd: TSpinEdit;
    btnSpd: TButton;
    btnVol: TButton;
    sbtnPro: TSpeedButton;
    sbtnRmW: TSpeedButton;
    sbtnRmS: TSpeedButton;
    btnStop: TBitBtn;
    BitBtn1: TBitBtn;
    Bevel1: TBevel;
    procedure btnPraClick(Sender: TObject);
    procedure btnPitClick(Sender: TObject);
    procedure btnRPrnClick(Sender: TObject);
    procedure btnRPitClick(Sender: TObject);
    procedure btnSpdClick(Sender: TObject);
    procedure btnVolClick(Sender: TObject);
    procedure btnMrkClick(Sender: TObject);
    procedure btnSpeakClick(Sender: TObject);
    procedure btnStopClick(Sender: TObject);
    procedure btnChrClick(Sender: TObject);
    procedure clbChrClickCheck(Sender: TObject);  
    procedure InsertTag(ThisTag : string);
    procedure btnRSpdClick(Sender: TObject);
    procedure btnPauClick(Sender: TObject);
    procedure btnComClick(Sender: TObject);
    procedure btnEngClick(Sender: TObject);
    procedure btnEmpClick(Sender: TObject);
    procedure btnDemClick(Sender: TObject);
    procedure btnResetClick(Sender: TObject);
    procedure btnCtxClick(Sender: TObject);
    procedure btnPrtClick(Sender: TObject);
    procedure sbtnProClick(Sender: TObject);
    procedure sbtnRmSClick(Sender: TObject);
    procedure sbtnRmWClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmInject: TfrmInject;
  reBackup : String;

implementation

uses TTSMain2;

{$R *.DFM}

procedure TfrmInject.InsertTag(ThisTag : string);
var
  S : string;
begin
  S := RichEdit1.Text;
  Insert(ThisTag, S, RichEdit1.SelStart + 1);
  RichEdit1.Text := S;
end;

procedure TfrmInject.btnPraClick(Sender: TObject);
begin
  InsertTag('\Pra=' + IntToStr(sePra.Value) + '\');
end;

procedure TfrmInject.btnPitClick(Sender: TObject);
begin
  InsertTag('\Pit=' + IntToStr(sePit.Value) + '\');
end;

procedure TfrmInject.btnRPrnClick(Sender: TObject);
begin
  InsertTag('\RPrn=' + IntToStr(seRPrn.Value) + '\');
end;

procedure TfrmInject.btnRPitClick(Sender: TObject);
begin
  InsertTag('\RPit=' + IntToStr(seRPit.Value) + '\');
end;

procedure TfrmInject.btnSpdClick(Sender: TObject);
begin
  InsertTag('\Spd=' + IntToStr(seSpd.Value) + '\');
end;

procedure TfrmInject.btnVolClick(Sender: TObject);
begin
  InsertTag('\Vol=' + IntToStr(seVol.Value) + '\');
end;

procedure TfrmInject.btnMrkClick(Sender: TObject);
begin
  InsertTag('\Mrk=' + IntToStr(seMrk.Value) + '\');
end;

procedure TfrmInject.btnSpeakClick(Sender: TObject);
var
  SData : TSData;
begin
  { Get the text to speak }
  SData.dwSize := length(RichEdit1.Text) + 1;
  SData.pData := pChar(RichEdit1.Text);
  Try
    { Set Flag to 1 to instruct the engine to process Control Tags }
    OleCheck(fITTSCentral.TextData (CHARSET_TEXT, 1,
      SData, pointer(fTTSBufNotifySink), IID_ITTSBufNotifySink));
  Except
    RichEdit1.Lines.Add('Speak '+ ' <Charset_Text> - Failed');
  end; {Except}
end;

procedure TfrmInject.btnStopClick(Sender: TObject);
begin
  try
    OleCheck(fITTSCentral.AudioReset);
  except
    RichEdit1.Lines.Add('Check AudioReset Failed');
  end;
end;

procedure TfrmInject.btnChrClick(Sender: TObject);
var
  I, J : Integer;
  ChrStr : string;
begin
  ChrStr := '\Chr="';
  J := NumChrSel;
  for I := 0 to clbChr.Items.Count - 1 do begin
    if clbChr.Checked[I] then begin
      dec(J);
      ChrStr := ChrStr + clbChr.Items[I];
      if J > 0 then ChrStr := ChrStr + ',';
    end;
  end;
  InsertTag(ChrStr + '"\');
end;

procedure TfrmInject.clbChrClickCheck(Sender: TObject);
begin
  if clbChr.Checked[clbChr.ItemIndex] then inc(NumChrSel)
    else dec(NumChrSel);
end;

procedure TfrmInject.btnRSpdClick(Sender: TObject);
begin
  InsertTag('\RSpd=' + IntToStr(seRSpd.Value) + '\');
end;

procedure TfrmInject.btnPauClick(Sender: TObject);
begin                                     
  InsertTag('\Pau=' + IntToStr(sePau.Value) + '\');
end;

procedure TfrmInject.btnComClick(Sender: TObject);
begin
  InsertTag('\Com=' + ebCom.Text + '\');
end;

procedure TfrmInject.btnEngClick(Sender: TObject);
begin
  InsertTag('\Eng=' + ebEng.Text + '\');
end;

procedure TfrmInject.btnEmpClick(Sender: TObject);
begin
  InsertTag('\Emp\');
end;

procedure TfrmInject.btnDemClick(Sender: TObject);
begin
  InsertTag('\Dem\');
end;

procedure TfrmInject.btnResetClick(Sender: TObject);
begin
  InsertTag('\Rst\');
  if MessageDlg('Do you want to remove the inserted Control Tags?', mtConfirmation,
                [mbYes, mbNo], 0) = mrYes then RichEdit1.Text  := reBackup;
end;

procedure TfrmInject.btnCtxClick(Sender: TObject);
begin
  InsertTag('\Ctx="' + cbxCtx.Items.Strings[cbxCtx.itemindex] + '"\');
end;

procedure TfrmInject.btnPrtClick(Sender: TObject);
begin
  InsertTag('\Prt="' + cbxPrt.Items.Strings[cbxPrt.ItemIndex] + '"\');
end;

procedure TfrmInject.sbtnProClick(Sender: TObject);
begin
  if sbtnPro.Down then begin
    InsertTag('\Pro=1\');
    Label6.Caption := 'On';
  end else begin
    InsertTag('\Pro=0\');       
    Label6.Caption := 'Off';
  end;
end;

procedure TfrmInject.sbtnRmSClick(Sender: TObject);
begin
  if sbtnRmS.Down then begin
    InsertTag('\RmS=1\');
    Label7.Caption := 'On';
  end else begin
    InsertTag('\RmS=0\');
    Label7.Caption := 'Off';
  end;
end;

procedure TfrmInject.sbtnRmWClick(Sender: TObject);
begin                                     
  if sbtnRmW.Down then begin
    InsertTag('\RmW=1\');
    Label8.Caption := 'On';
  end else begin
    InsertTag('\RmW=0\');
    Label8.Caption := 'Off';
  end;
end;

procedure TfrmInject.FormCreate(Sender: TObject);
begin
  reBackup := RichEdit1.Text;
end;

end.
