{************************************************************************}
{                                                                        }
{       Borland Delphi Runtime Library                                   }
{       Speech interface unit                                            }
{                                                                        }
{ Portions created by Microsoft are                                      }
{ Copyright (C) 1995-2000 Microsoft Corporation.                         }
{ All Rights Reserved.                                                   }
{                                                                        }
{ The original file is: Spchtel.h, released 12 Jan 1999.                 }
{ The original Pascal code is: Spchtel.pas, released 07 Jul 1999.        }
{ The initial developer of the Pascal code is Alec Bergamini             }
{ (alecb@o2a.com).                                                       }
{                                                                        }
{ Portions created by Alec Bergamini are                                 }
{ Copyright (C) 1999, 2000 O&A Productions.                              }
{                                                                        }
{ Contributor(s): Alex Hekstra, Bob Bortolin                             }
{                                                                        }
{       Obtained through:                                                }
{                                                                        }
{       Joint Endeavour of Delphi Innovators (Project JEDI)              }
{                                                                        }
{ You may retrieve the latest version of this file at the Project        }
{ JEDI home page, located at http://delphi-jedi.org                      }
{                                                                        }
{ The contents of this file are used with permission, subject to         }
{ the Mozilla Public License Version 1.1 (the "License"); you may        }
{ not use this file except in compliance with the License. You may       }
{ obtain a copy of the License at                                        }
{ http://www.mozilla.org/MPL/MPL-1.1.html                                }
{                                                                        }
{ Software distributed under the License is distributed on an            }
{ "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or         }
{ implied. See the License for the specific language governing           }
{ rights and limitations under the License.                              }
{                                                                        }
{************************************************************************}

unit Spchtel;

interface

uses Windows, classes, ActiveX, ComObj, messages, speech;

{$HPPEMIT '#include <Spchtel.h>'}

{$HPPEMIT 'typedef System::DelphiInterface<ITelNotifySink> _di_ITelNotifySink;'}
{$HPPEMIT 'typedef System::DelphiInterface<ITelControlNotifySink> _di_ITelControlNotifySink;'}
{$HPPEMIT 'typedef System::DelphiInterface<ITelInfo> _di_ITelInfo;'}
{$HPPEMIT 'typedef System::DelphiInterface<ITelControl> _di_ITelControl;'}

const
// Flag values for the ITelControl::TypeSet call
  {$EXTERNALSYM INFOTYPE_PC}
  INFOTYPE_PC         = $00000001;
  {$EXTERNALSYM INFOTYPE_TAPI20}
  INFOTYPE_TAPI20     = $00000002;
  {$EXTERNALSYM INFOTYPE_TAPI30}
  INFOTYPE_TAPI30     = $00000004;

// Common return codes from controls
// not usually handled, often returned
  {$EXTERNALSYM TCR_ABORT}
  TCR_ABORT         = DWORD(-1);      // the user has hung up
  {$EXTERNALSYM TCR_NORESPONSE}
  TCR_NORESPONSE    = DWORD(-2);      // the user hasn't repsonded to the questions
  {$EXTERNALSYM TCR_ASKOPERATOR}
  TCR_ASKOPERATOR   = DWORD(-3);      // the user has asked for an operator (often control just auto replies)
  {$EXTERNALSYM TCR_ASKHANGUP}
  TCR_ASKHANGUP     = DWORD(-4);      // the user has asked to hang up. App must handle
  {$EXTERNALSYM TCR_ASKBACK}
  TCR_ASKBACK       = DWORD(-5);      // the user has asked to go back and redo the previous thing
// usually handled by control, unless overrided
  {$EXTERNALSYM TCR_ASKWHERE}
  TCR_ASKWHERE      = DWORD(-10);     // the user has asked where he/she is (usualy handled by control)
  {$EXTERNALSYM TCR_ASKHELP}
  TCR_ASKHELP       = DWORD(-11);     // the user has asked for help (usually handled by control)
  {$EXTERNALSYM TCR_ASKREPEAT}
  TCR_ASKREPEAT     = DWORD(-12);     // the user has asked for the question to be repeated (usually handled by the control)
  {$EXTERNALSYM TCR_ASKSPEAKFASTER}
  TCR_ASKSPEAKFASTER = DWORD(-13);    // the user has asked to speak faster. usually handled by the control
  {$EXTERNALSYM TCR_ASKSPEAKSLOWER}
  TCR_ASKSPEAKSLOWER = DWORD(-14);    // the user has asked to speak slower. Usually handled by the control
// CLASS IDs
  {$EXTERNALSYM CLSID_TelInfo}
  CLSID_TelInfo: TGUID = '{f9d18bf8-e0ed-11d0-ab8b-08002be4e3b7}';
  {$EXTERNALSYM CLSID_YesNoControl}
  CLSID_YesNoControl: TGUID = '{53961A01-459B-11d1-BE77-006008317CE8}';
  {$EXTERNALSYM CLSID_ExtensionControl}
  CLSID_ExtensionControl: TGUID = '{53961A02-459B-11d1-BE77-006008317CE8}';
  {$EXTERNALSYM CLSID_PhoneNumControl}
  CLSID_PhoneNumControl: TGUID = '{53961A03-459B-11d1-BE77-006008317CE8}';
  {$EXTERNALSYM CLSID_GrammarControl}
  CLSID_GrammarControl: TGUID = '{53961A04-459B-11d1-BE77-006008317CE8}';
  {$EXTERNALSYM CLSID_DateControl}
  CLSID_DateControl: TGUID = '{53961A05-459B-11d1-BE77-006008317CE8}';
  {$EXTERNALSYM CLSID_TimeControl}
  CLSID_TimeControl: TGUID = '{53961A06-459B-11d1-BE77-006008317CE8}';
  {$EXTERNALSYM CLSID_RecordControl}
  CLSID_RecordControl: TGUID = '{53961A07-459B-11d1-BE77-006008317CE8}';
  {$EXTERNALSYM CLSID_SpellingControl}
  CLSID_SpellingControl: TGUID = '{53961A08-459B-11d1-BE77-006008317CE8}';
  {$EXTERNALSYM CLSID_NameControl}
  CLSID_NameControl: TGUID = '{53961A09-459B-11d1-BE77-006008317CE8}';
  (* Sample telephony controls GUIDs. These samples appear in the MS Speech SDK. *)
  {$EXTERNALSYM CLSID_SampleYesNoControl}
  CLSID_SampleYesNoControl: TGUID = '{C869F0DE-EF29-11d0-8FAD-08002BE4E62A}';
  {$EXTERNALSYM CLSID_SampleExtensionControl}
  CLSID_SampleExtensionControl: TGUID = '{9DE44BA9-F94A-11d0-8FAD-08002BE4E62A}';
  {$EXTERNALSYM CLSID_SamplePhoneNumControl}
  CLSID_SamplePhoneNumControl: TGUID = '{9DE44BAA-F94A-11d0-8FAD-08002BE4E62A}';
  {$EXTERNALSYM CLSID_SampleGrammarControl}
  CLSID_SampleGrammarControl: TGUID = '{9DE44BAB-F94A-11d0-8FAD-08002BE4E62A}';
  {$EXTERNALSYM CLSID_SampleDateControl}
  CLSID_SampleDateControl: TGUID = '{9DE44BAC-F94A-11d0-8FAD-08002BE4E62A}';
  {$EXTERNALSYM CLSID_SampleTimeControl}
  CLSID_SampleTimeControl: TGUID = '{9DE44BAD-F94A-11d0-8FAD-08002BE4E62A}';
  {$EXTERNALSYM CLSID_SampleRecordControl}
  CLSID_SampleRecordControl: TGUID = '{275931C6-FD27-11d0-8FAE-08002BE4E62A}';
  {$EXTERNALSYM CLSID_SampleSpellingControl}
  CLSID_SampleSpellingControl: TGUID = '{9DE44BAE-F94A-11d0-8FAD-08002BE4E62A}';
  {$EXTERNALSYM CLSID_SampleNameControl}
  CLSID_SampleNameControl: TGUID = '{9DE44BAF-F94A-11d0-8FAD-08002BE4E62A}';
// INTERFACE IDs
  {$EXTERNALSYM IID_ITelNotifySink:}
  IID_ITelNotifySink: TGUID = '{CD0C7D7C-E1CD-11d0-AB8B-08002BE4E3B7}';
  {$EXTERNALSYM IID_ITelControlNotifySink:}
  IID_ITelControlNotifySink: TGUID = '{A55E2436-E297-11d0-AB8B-08002BE4E3B7}';
  {$EXTERNALSYM IID_ITelInfo:}
  IID_ITelInfo: TGUID = '{250F0433-E0EB-11d0-AB8B-08002BE4E3B7}';
  {$EXTERNALSYM IID_ITelControl:}
  IID_ITelControl: TGUID = '{17674DEB-E298-11d0-AB8B-08002BE4E3B7}';
  // GUID identifiers for objects
  {$EXTERNALSYM TELOBJ_SPEECHRECOG:}
  TELOBJ_SPEECHRECOG: TGUID = '{44DB6739-E10E-11d0-AB8B-08002BE4E3B7}';
  {$EXTERNALSYM TELOBJ_TTSQUEUE:}
  TELOBJ_TTSQUEUE: TGUID = '{44DB673B-E10E-11d0-AB8B-08002BE4E3B7}';
  {$EXTERNALSYM TELOBJ_LOGGING:}
  TELOBJ_LOGGING: TGUID = '{44DB673C-E10E-11d0-AB8B-08002BE4E3B7}';
  {$EXTERNALSYM TELOBJ_TAPI30:}
  TELOBJ_TAPI30: TGUID = '{44DB673D-E10E-11d0-AB8B-08002BE4E3B7}';
  {$EXTERNALSYM TELOBJ_NOTIFYSINK:}
  TELOBJ_NOTIFYSINK: TGUID = '{44DB673E-E10E-11d0-AB8B-08002BE4E3B7}';
  // hcall for TAPI
  {$EXTERNALSYM TELDWORD_HCALL:}
  TELDWORD_HCALL: TGUID = '{F40CC4C0-0D0A-11d2-BEF0-006008317CE8}';
  // hline for tapi
  {$EXTERNALSYM TELDWORD_HLINE:}
  TELDWORD_HLINE: TGUID = '{F40CC4C1-0D0A-11d2-BEF0-006008317CE8}';
  // If this is set to TRUE, then beeps on a recognition are enabled.
  // Disabling speeds up the response time of the system, but some people
  // will speak before the beep. It's a tradeoff.
  {$EXTERNALSYM TELDWORD_EnableRecognizeBeeps:}
  TELDWORD_EnableRecognizeBeeps: TGUID = '{DB7F6130-0D2D-11d2-BEF1-006008317CE8}';
  // if set to true, and we're using tapi, then we should use tapi
  // beeps rather than recordings for recognition acknowledgement
  // beeps. This doesn't work properly on most telephony cards, and there's no
  // way to tell, so be careful about using it
  {$EXTERNALSYM TELDWORD_UseTAPIBeep:}
  TELDWORD_UseTAPIBeep: TGUID = '{F40CC4C2-0D0A-11d2-BEF0-006008317CE8}';
  // disable the ability for a user to change the speed
  {$EXTERNALSYM TELDWORD_DisableSpeedChange:}
  TELDWORD_DisableSpeedChange: TGUID = '{59596FBE-F936-11d0-8FAD-08002BE4E62A}';
  // enable the ability for the user to ask for an operator
  {$EXTERNALSYM TELDWORD_EnableOperator:}
  TELDWORD_EnableOperator: TGUID = '{59596FBF-F936-11d0-8FAD-08002BE4E62A}';
  // eanble the user to ask to hang up. If TRUE application must handle
  {$EXTERNALSYM TELDWORD_EnableAskHangUp:}
  TELDWORD_EnableAskHangUp: TGUID = '{59596FC0-F936-11d0-8FAD-08002BE4E62A}';
  // if TRUE, then the system supports full duplex
  // both full duplex and echo cancelling must be TRUE for telephony controls to have barge in
  {$EXTERNALSYM TELDWORD_FullDuplex:}
  TELDWORD_FullDuplex: TGUID = '{10FEF992-343F-11d1-BE71-006008317CE8}';
  // if TRUE, then the system has echo cancelling built in.
  // both full duplex and echo cancelling must be TRUE for telephony controls to have barge in
  {$EXTERNALSYM TELDWORD_EchoCancel:}
  TELDWORD_EchoCancel: TGUID = '{10FEF991-343F-11d1-BE71-006008317CE8}';

  SID_ITelNotifySink         = '{CD0C7D7C-E1CD-11d0-AB8B-08002BE4E3B7}';
  SID_ITelControlNotifySink  = '{A55E2436-E297-11d0-AB8B-08002BE4E3B7}';
  SID_ITelInfo               = '{250F0433-E0EB-11d0-AB8B-08002BE4E3B7}';
  SID_ITelControl            = '{17674DEB-E298-11d0-AB8B-08002BE4E3B7}';

type  
  {$EXTERNALSYM ITelNotifySink}
  ITelNotifySink = Interface( IUnknown )
    [SID_ITelNotifySink]
    function DTMF(wcDTMF: WideChar) : HResult; stdcall;
    function Abort(dwReason: DWORD) : HResult; stdcall;
  end;
  {$EXTERNALSYM PITelNotifySink}
  PITelNotifySink = ^ITelNotifySink;

  {$EXTERNALSYM ITelControlNotifySink}
  ITelControlNotifySink = Interface( IUnknown )
    [SID_ITelControlNotifySink]
    function Finish(dwValue: DWORD; pMem: pointer; dwSize: DWORD) : HResult; stdcall;
    function Info(dwValue: DWORD; pMem: pointer; dwSize: DWORD): HResult; stdcall;
  end;
  {$EXTERNALSYM PITelControlNotifySink}
  PITelControlNotifySink = ^ITelControlNotifySink;

  {$EXTERNALSYM ITelInfo}
  ITelInfo = interface( IUnknown )
    [SID_ITelInfo]
    function ObjectGet(guid: TGUID; var IUnk: IUNKNOWN): HResult; stdcall;
    function ObjectSet(guid: TGUID; IUnk: IUNKNOWN): HResult; stdcall;
    function DWORDGet(guid: TGUID; var dwValue: DWORD): HResult; stdcall;
    function DWORDSet(guid: TGUID; dwValue: DWORD): HResult; stdcall;
    function MemoryGet(guid: TGUID; var pMem: pointer; var dwSize: DWORD): HResult; stdcall;
    function MemorySet(guid: TGUID; pMem: pointer; dwSize: DWORD): HResult; stdcall;
    function SendDTMF(wcDTMF: WideChar): HResult; stdcall;
    function SendAbort(dwReason: DWORD): HResult; stdcall;
    function TypeSet(dwType: DWORD): HResult; stdcall;
    function WaveDeviceSet(dwNotDocumented1: DWORD; dwNotDocumented2: DWORD): HResult; stdcall;
    function AudioSourceCreate(var IUnk: IUNKNOWN): HResult; stdcall;
    function AudioDestCreate(var IUnk: IUNKNOWN): HResult; stdcall;
    function QuickCreate(hModule: HMODULE; pSRModeInfo: PSRMODEINFOW;
      pTTSModeInfo: PTTSMODEINFOW; pszWave: PWideString; fNotDocumented: BOOL): HResult; stdcall;
  end;
  {$EXTERNALSYM PITelInfo}
  PITelInfo = ^ITelInfo;

  {$EXTERNALSYM ITelInfo}
  ITelControl = interface( IUnknown )
    [SID_ITelControl]
    function FromMemory(Mem: Pointer; dwSize: DWORD): HResult; stdcall;
    function FromStream(IStream: ISTREAM): HResult; stdcall;
    function FromResource(hInst: HINST; dwNum: DWORD): HResult; stdcall;
    function FromFile(szFile: PWideChar): HResult; stdcall;
    function Compile(var szError: PWideChar; var wSize: DWORD): HResult; stdcall;
    function IsCompiled(var fCompiled: BOOL): HResult; stdcall;
    function LanguageGet(var Lang: LANGUAGEW): HResult; stdcall;
    function ToMemory(var pMem: Pointer; var dwSize: DWORD): HResult; stdcall;
    function ToStream(IStream: IStream): HResult; stdcall;
    function ToFile(szFile: PWideChar): HResult; stdcall;
    function TextGet(var szText: PWideChar; var dwSize: DWORD): HResult; stdcall;
    function TextDefaultGet(var pszText: PWideChar; var dwSize: DWORD): HResult; stdcall;
    function ObjectSet(pITelInfo: PITELINFO): HResult; stdcall;
    function Start(pITelControlNotifySink: PITELCONTROLNOTIFYSINK): HResult; stdcall;
    function Abort: HResult; stdcall;
  end;
  {$EXTERNALSYM PITelControl}
  PITelControl = ^ITelControl;

implementation

end. // The fat lady sang
  
